var OLMap = {
	map : null,
	createMap : function() {
		OLMap.map = new OpenLayers.Map ({
			div : "map",
			controls:[
				new OpenLayers.Control.Navigation(),
				new OpenLayers.Control.PanZoom(),
				],
			//maxExtent: new OpenLayers.Bounds(-20037508.34,-20037508.34,20037508.34,20037508.34),
			//maxResolution: 156543.0399,
			//zoom: 2,
			//numZoomLevels: 5,
			//minZoomLevel: 5,
			//units: 'm',
			//projection: new OpenLayers.Projection("EPSG:900913"),
			//displayProjection: new OpenLayers.Projection("EPSG:4326"),
			//baseLayer: new OpenLayers.Layer.OSM()
		});
		var baseLayer = new OpenLayers.Layer.OSM();
		OLMap.map.addLayer(baseLayer);
		OLMap.map.setBaseLayer(baseLayer);
	},
	addTrail : function(uri, color) {
		var layer = new OpenLayers.Layer.GML(uri, uri, {
			format: OpenLayers.Format.GPX,
			style: {strokeColor: color, strokeWidth: 5, strokeOpacity: 0.5},
			projection: new OpenLayers.Projection("EPSG:4326")
		});
		OLMap.map.addLayer(layer);
	},
	centerMap : function(events) {
		var bounds = OLMap.getBounds(events);
		var lonLat = bounds.getCenterLonLat().transform(new OpenLayers.Projection("EPSG:4326"), OLMap.map.getProjectionObject());
		OLMap.map.setCenter(lonLat, OLMap.map.getZoomForExtent(bounds.transform(new OpenLayers.Projection("EPSG:4326"), OLMap.map.getProjectionObject())));
	},
	getBounds : function(events) {
		var minLat = events[0].c[0];
		var maxLat = minLat;
		var minLong = events[0].c[1];
		var maxLong = minLong;
		for (i=1; i < events.length; i++) {
			if (!events[i].c)
				continue;
			if ((lat = events[i].c[0]) < minLat) {
				minLat = lat;
				continue;
			} if ((lat = events[i].c[0]) > maxLat) {
				maxLat = lat;
				continue;
			} if ((longi = events[i].c[1]) < minLong) {
				minLong = longi;
				continue;
			} if ((longi = events[i].c[1]) > maxLong) {
				maxLong = longi;
				continue;
			}
		}
		bounds = new OpenLayers.Bounds();
		bounds.extend(new OpenLayers.LonLat(minLong,minLat));
		bounds.extend(new OpenLayers.LonLat(maxLong,maxLat));
		return bounds;
	},
	clearMap : function() {
		var gmlLayers = OLMap.map.getLayersByClass('OpenLayers.Layer.GML');
		for (var i=0; i < gmlLayers.length; i++) {
		  gmlLayers[i].destroy();
		};
	},
	
}

var workouts, graph;

function getWorkouts() {
	workouts = Util.requestJSON('/user/dummy@example.com/workouts');
	return workouts;
	//return Util.requestJSON('http://localhost:2719/user/jdoe/workouts');
	//return [ { "activity": "http://dbpedia.org/resource/Running", "date": 1312971214000, "duration": 6652, "distance": 12.000000, "json": "http://localhost:2719/user/dummy@example.com/workout/4e56a110ccf2406c3515bccb.json", "gpx": "http://localhost:2719/user/dummy@example.com/workout/4e56a110ccf2406c3515bccb.gpx" }, { "activity": "http://dbpedia.org/resource/Running", "date": 1309083594000, "duration": 14703, "distance": 12.000000, "json": "http://localhost:2719/user/dummy@example.com/workout/4e56a250ccf23d3128a27d0f.json", "gpx": "http://localhost:2719/user/dummy@example.com/workout/4e56a250ccf23d3128a27d0f.gpx" } ];
}

function getWorkout(uri) {
	return Util.requestJSON(uri);
	//return Util.requestJSON(uri);
}

function toggleLoader() {
	
}

function updateHistory(workouts) {
	var parent = document.getElementById('history');
	var list = parent.getElementsByTagName('ul')[0];
	var newList = document.createElement('ul');
	for (var i=0; i < workouts.length; i++) {
	  var li = document.createElement('li');
	  //li.className = "workout_" + i;
	  var link = document.createElement('a');
	  link.setAttribute('onclick', 'javascript:showResult(workouts[' + i + '])');
	  link.href = "#workout_" + i;
	  link.innerHTML = getActivity(workouts[i].activity) + " " + Util.formatDate(workouts[i].date);
	  li.appendChild(link); 
	  newList.appendChild(li);
	};
	parent.replaceChild(newList, list);
}

function updateStats(workout) {
	var list = document.getElementById('stats').getElementsByTagName('ul')[0];
	list.getElementsByClassName('date')[0].getElementsByTagName('span')[0].innerHTML = Util.formatDate(workout.date);
	list.getElementsByClassName('start')[0].getElementsByTagName('span')[0].innerHTML = Util.formatTime2(workout.date);
	list.getElementsByClassName('duration')[0].getElementsByTagName('span')[0].innerHTML = Util.formatTime(workout.duration);
	list.getElementsByClassName('distance')[0].getElementsByTagName('span')[0].innerHTML = Util.formatDistance(workout.distance);
	list.getElementsByClassName('pace')[0].getElementsByTagName('span')[0].innerHTML = computePace(workout.distance, workout.duration) + ' min/km';
	list.getElementsByClassName('speed')[0].getElementsByTagName('span')[0].innerHTML = computeSpeed(workout.distance, workout.duration) + ' km/h';
	list.getElementsByClassName('climb')[0].getElementsByTagName('span')[0].innerHTML = getAscent(workout.events) + ' meters';
}

// TODO
function getActivity(type) {
	return type.replace('http://dbpedia.org/resource/','');
}

function getAscent(events) {
	var first, last;
	first = (function() {
		var i = 0;
		while (!events[i].c) {
			i++;
			if (!events[i])
				return 0;
			continue;
		}
		return events[i].c[2];
	})();
	last = (function() {
		var i = events.length - 1;
		while (!events[i].c) {
			i--;
			if (!events[i])
				return 0;
			continue;
		}
		return events[i].c[2];
	})();
	return last - first;
}

// returns min/km
function computePace(distance, duration) {
	return Util.formatTime((Math.round((duration/60)/(distance/1000)*100)/100)*60);
}

// returns km/h
function computeSpeed(distance, duration) {
	return Math.round((distance/1000)/(duration/3600)*100)/100;
}

function showResult(workout) {
	// update the map
	OLMap.clearMap();
	OLMap.addTrail(workout.gpx, "red");
	// fetch the json data containing the events
	workout = getWorkout(workout.json);
	// center the map on the events
	OLMap.centerMap(workout.events);
	//TODO: store
	// update the stats section
	updateStats(workout);
	
	// draw the speed graph
	
	graph.drawSpeedGraph(workout);
	
}
