package org.w3.virtualtrainer.test

import com.novus.salat._
import com.novus.salat.global._
import com.mongodb.casbah.Imports._
import com.novus.salat.annotations._

import com.novus.salat.dao._
import com.mongodb.casbah.MongoConnection

case class Workout(@Key("_id") id: ObjectId = new ObjectId,
                  activity:String,
                  events:List[Event])
                  
case class Event(@Key("t") timestamp:Long,
                 @Key("c") coordinates:Option[(Double, Double, Option[Double])],
                 @Key("s") status:Option[String])            

import org.scalatest.FunSuite

class Test extends FunSuite {

  test("") {

    val workout =
      Workout(
          activity="http://dbpedia.org/resource/Running",
          events=List(
              Event(timestamp=1314049555597L, coordinates=Some((-71.09068298339844,42.361671924591064,Some(66))), status=None),
              Event(timestamp=1314049559622L, coordinates=None, status=Some("pause"))
          )
      )
    
      val serialized = grater[Workout].asDBObject(workout)
      
      println(serialized)
      
      val unserialized = grater[Workout].asObject(serialized)
      
      println(unserialized)

  }

}

