package org.w3.virtualtrainer

import org.w3.virtualtrainer.util.RequestHelper

import org.specs._
import java.net.URL
import unfiltered.response._
import unfiltered.request._
import dispatch._

object WorkoutAPISpec extends Specification("Specification for the Workout API") with unfiltered.spec.jetty.Served {

  def setup = { _.filter(VirtualTrainerApp.workoutAPI) }

  val workout = """
{
 "activity": "http://dbpedia.org/resource/Running",
 "date": 1314049555595,
 "distance": 5000,
 "duration": 1234,
 "userAgent": "panda-en-feu",
 "events":
 [
  {
   "t": 1314049555597,
   "c": [-71.09068298339844,42.361671924591064,66]
  },
  {
   "t": 1314049559622,
   "s": "pause"
  },
  {
   "t": 1314549555597,
   "c": [-71.09068298339844,42.361671924591064,66]
  },
  {
   "t": 1315049559622,
   "s": "pause"
  }
 ]
}
"""
  
  "POST workout" should {
    val POSTworkout = host / "user" / "jdoe" / "workout"
    "return a location telling where the workout is GETtable" in {
      val locationHeader:String = Http(RequestHelper.POST(POSTworkout, workout) >:> { headers =>
        headers get "Location" getOrElse sys.error("no Location header") head
      })
      val locationURL = new URL(locationHeader)
      locationURL.getHost must_== POSTworkout.host.getHostName
      locationURL.getPort must_== POSTworkout.host.getPort
      val run = Http(url(locationHeader) as_str)
      run must not be empty
    }
  }
  
}

object PlaySpec extends Specification with unfiltered.spec.jetty.Served {

  def setup = { _.filter(VirtualTrainerApp.workoutAPI) }
  
  "GET" should {
    val get = host / "user" / "jdoe" / "workouts"
    "return what I want" in {
      val workouts = Http(get as_str)
      println(workouts)
    }
  }
  
}